using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Drawing;
//using System.Windows.Input;

namespace FARRTunes
{
     public static class EnumTray
    {
        private static IntPtr _systray = IntPtr.Zero;
        private static int TrayItemCount;
        //private TrayIconData[] ButtonData;

        public static void GetTrayData(out TrayIconData[] ButtonData)
        {
            _systray = FindTray();
            TrayItemCount = GetTrayIconCount();
            ButtonData = getButtons();

            //_systray = FindClock();
            //TrayItemCount = GetTrayIconCount();
            //ButtonData = getButtons();            
        }

         public static IntPtr GetTrayClock()
         {
             return FindClock();
         }

        private static IntPtr FindTray()
        {
            IntPtr hwndParent = NativeMethods.FindWindow("Shell_TrayWnd", null);
            IntPtr hwndTray = NativeMethods.FindWindowEx(hwndParent, IntPtr.Zero, "TrayNotifyWnd", null);
            IntPtr hwndPager = NativeMethods.FindWindowEx(hwndTray, IntPtr.Zero, "SysPager", null);
            hwndParent = NativeMethods.FindWindowEx(hwndPager, IntPtr.Zero, "ToolbarWindow32", null);
            return hwndParent;
        }

         private static IntPtr FindClock()
         {
             IntPtr hwndParent = NativeMethods.FindWindow("Shell_TrayWnd", null);
             IntPtr hwndTray = NativeMethods.FindWindowEx(hwndParent, IntPtr.Zero, "TrayNotifyWnd", null);
             IntPtr hwndPager = NativeMethods.FindWindowEx(hwndTray, IntPtr.Zero, "SysPager", null);
             hwndParent = NativeMethods.FindWindowEx(hwndPager, IntPtr.Zero, "TrayClockWClass", null);
             return hwndParent;
         }

        private static int GetTrayIconCount()
        {
            uint TB_BUTTONCOUNT = 0x418;
            int iconCount = (int)NativeMethods.SendMessage(_systray, TB_BUTTONCOUNT, IntPtr.Zero, IntPtr.Zero);
            return iconCount;
        }

        private static unsafe TrayIconData[] getButtons()
        {
            byte[] buffer = new byte[4096];
            TrayIconData[] data = new TrayIconData[1];
            //Find Explorers PID
            uint ExplorerPID = 0;
            NativeMethods.GetWindowThreadProcessId(_systray, out ExplorerPID);
            //Hence get an hProcess
            IntPtr hProcess = NativeMethods.OpenProcess(2035711, false, ExplorerPID);
            if (hProcess != IntPtr.Zero)
            {
                //Allocate some memory for the button data
                IntPtr butt = NativeMethods.VirtualAllocEx(hProcess, IntPtr.Zero, new UIntPtr(4096), 4096, 4);
                int length = TrayItemCount;
                data = new TrayIconData[length];
                for (int id = 0; id < length; id++)
                {
                    data[id] = new TrayIconData();
                    fixed (TBBUTTON* tbbuttonRef = &data[id].button)
                    {
                        IntPtr lpBuffer = new IntPtr((void*)tbbuttonRef);
                        //Get the button data for the id-th button, let it get written to the memory we allocated 
                        NativeMethods.SendMessage(_systray, 1047, new IntPtr(id), butt);
                        int num = 0;
                        IntPtr lpNumberOfBytesRead = new IntPtr((void*)&num);
                        //Read the data back in to our TBBUTTON structure
                        if (NativeMethods.ReadProcessMemory(hProcess, butt, lpBuffer, new UIntPtr((uint)sizeof(TBBUTTON)), out lpNumberOfBytesRead))
                        {
                            //Create a fixed TRAYDATA structure
                            fixed (TRAYDATA* traydataRef = &data[id].traydata)
                            {
                                IntPtr ptr5 = new IntPtr((void*)traydataRef);
                                //Read the value back in to our TRAYDATA structure
                                NativeMethods.ReadProcessMemory(hProcess, new IntPtr(data[id].button.dwData), ptr5, new UIntPtr((uint)sizeof(TRAYDATA)), out lpNumberOfBytesRead);
                            }
                            fixed (byte* numRef = buffer)
                            {
                                //Get the button's text in to the allocated memory
                                int len = (int)NativeMethods.SendMessage(_systray, 1099, (IntPtr)data[id].button.idCommand, butt);
                                if (len != -1)
                                {
                                    //And read it back, putting it in the text object
                                    IntPtr ptr6 = new IntPtr((void*)numRef);
                                    if (NativeMethods.ReadProcessMemory(hProcess, butt, ptr6, new UIntPtr(4096), out lpNumberOfBytesRead))
                                        data[id].Text = Marshal.PtrToStringAuto(ptr6, len);
                                    else
                                        data[id].Text = "";
                                }
                                else
                                    data[id].Text = "";
                            }
                        }
                    }
                }
                NativeMethods.VirtualFreeEx(hProcess, butt, UIntPtr.Zero, 32768);
            }
            return data;
        }

         public static Bitmap MakeIcon(TrayIconData ButtonData)
         {
             Bitmap icon = (Bitmap)Bitmap.FromHicon(ButtonData.traydata.hIcon).Clone(); 
             //Icon temp = (Icon)Icon.FromHandle(ButtonData.traydata.hIcon).Clone();
             //Icon icon = new Icon(temp, new Size(32, 32));
             NativeMethods.DestroyIcon(ButtonData.traydata.hIcon);
             return icon;
         }

         public static void LeftClickEvent(TrayIconData ButtonData)
         {
             NativeMethods.PostMessage(ButtonData.traydata.hwnd, ButtonData.traydata.uCallbackMessage, (int)ButtonData.traydata.uID, 0x201);
             NativeMethods.PostMessage(ButtonData.traydata.hwnd, ButtonData.traydata.uCallbackMessage, (int)ButtonData.traydata.uID, 0x202);
             //NativeMethods.PostMessage(ButtonData.traydata.hwnd, 0x201, (int)ButtonData.traydata.uID, 0x201);
             //NativeMethods.PostMessage(ButtonData.traydata.hwnd, 0x202, (int)ButtonData.traydata.uID, 0x202);
             NativeMethods.SetForegroundWindow(ButtonData.traydata.hwnd);
         }

         public static void RightClickEvent(TrayIconData ButtonData)
         {
             NativeMethods.PostMessage(ButtonData.traydata.hwnd, ButtonData.traydata.uCallbackMessage, (int)ButtonData.traydata.uID, 0x204);
             NativeMethods.PostMessage(ButtonData.traydata.hwnd, ButtonData.traydata.uCallbackMessage, (int)ButtonData.traydata.uID, 0x205);
             NativeMethods.SetForegroundWindow(ButtonData.traydata.hwnd);
         }

         public static void DoubleLeftClickEvent(TrayIconData ButtonData)
         {
             NativeMethods.PostMessage(ButtonData.traydata.hwnd, ButtonData.traydata.uCallbackMessage, (int)ButtonData.traydata.uID, 0x203);
             NativeMethods.SetForegroundWindow(ButtonData.traydata.hwnd);
         }

         public static void LeftClickClockEvent(IntPtr HClock)
         {
             NativeMethods.PostMessage(HClock, 0x201, 0, 0x201);
             NativeMethods.PostMessage(HClock, 0x202, 0, 0x202);
             NativeMethods.SetForegroundWindow(HClock);
         }

         public static void RightClickClockEvent(IntPtr HClock)
         {
             NativeMethods.PostMessage(HClock, 0x204, 0, 0x204);
             NativeMethods.PostMessage(HClock, 0x205, 0, 0x205);
             NativeMethods.SetForegroundWindow(HClock);
         }

         public static void DoubleLeftClickClockEvent(IntPtr HClock)
         {
             NativeMethods.PostMessage(HClock, 0x203, 0, 0x203);
             NativeMethods.SetForegroundWindow(HClock);
         }

         public static RECT FARRWinPos()
         {
             IntPtr hwndParent = NativeMethods.FindWindow("TMainForm", null);
             RECT rect;
             NativeMethods.GetWindowRect(hwndParent, out rect);
             return rect;
         }
    }
    internal static class NativeMethods
    {
        [DllImport("user32.dll", SetLastError = true)]
        internal static extern IntPtr FindWindow(string lpClassName, string lpWindowName);

        [DllImport("user32.dll", SetLastError = true)]
        internal static extern IntPtr FindWindowEx(IntPtr hwndParent, IntPtr hwndChildAfter, string lpszClass, string lpszWindow);

        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = false)]
        internal static extern IntPtr SendMessage(IntPtr hWnd, uint Msg, IntPtr wParam, IntPtr lParam);

        [DllImport("user32.dll", SetLastError = true)]
        internal static extern uint GetWindowThreadProcessId(IntPtr hWnd, out uint lpdwProcessId);

        [DllImport("kernel32.dll")]
        internal static extern IntPtr OpenProcess(uint dwDesiredAccess, [MarshalAs(UnmanagedType.Bool)] bool bInheritHandle, uint dwProcessId);

        [DllImport("kernel32.dll", SetLastError = true, ExactSpelling = true)]
        internal static extern IntPtr VirtualAllocEx(IntPtr hProcess, IntPtr lpAddress, UIntPtr dwSize, uint flAllocationType, uint flProtect);

        [DllImport("kernel32.dll", SetLastError = true)]
        internal static extern bool ReadProcessMemory(IntPtr hProcess, IntPtr lpBaseAddress, IntPtr lpBuffer, UIntPtr dwSize, out IntPtr lpNumberOfBytesRead);

        [DllImport("kernel32.dll", SetLastError = true, ExactSpelling = true)]
        internal static extern bool VirtualFreeEx(IntPtr hProcess, IntPtr lpAddress, UIntPtr dwSize, uint dwFreeType);

        [return: MarshalAs(UnmanagedType.Bool)]
        [DllImport("user32.dll", SetLastError = true)]
        internal static extern bool PostMessage(IntPtr hWnd, uint Msg, int wParam, int lParam);

        [DllImport("user32.dll", SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        internal static extern bool DestroyIcon(IntPtr hIcon);

        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        internal static extern bool SetForegroundWindow(IntPtr hWnd);

        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        internal static extern bool GetWindowRect(IntPtr hWnd, out RECT lpRect);
    }


    [StructLayout(LayoutKind.Sequential)]
    public struct TRAYDATA
    {
        public IntPtr hwnd;
        public uint uID;
        public uint uCallbackMessage;
        private uint Reserved;
        private uint Reserved2;
        public IntPtr hIcon;
    }

    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public struct TBBUTTON
    {
        public int iBitmap;
        public int idCommand;
        public byte fsState;
        public byte fsStyle;
        public byte bReserved0;
        public byte bReserved1;
        public int dwData;
        public int iString;
    }

    public class TrayIconData
    {
        public TrayIconData()
        {
            button = new TBBUTTON();
            traydata = new TRAYDATA();
            Text = " ";
        }
        public TBBUTTON button;
        public TRAYDATA traydata;
        public string Text;
    }

    [StructLayout(LayoutKind.Sequential)]
    public struct RECT
    {
        public int Left;
        public int Top;
        public int Right;
        public int Bottom;
    }
}
