﻿using System;
using System.Collections.Generic;
using System.Text;
using FARRPlugin;
using System.Drawing;
using System.Reflection;
using System.IO;
using System.Windows.Forms;
using System.Diagnostics;

namespace FARRTunes.Actions
{
    class FARRTrayAction : ActionItem
    {
        //private readonly FARRPluginBase pluginBase;
        //public FARRTrayAction(FARRPluginBase pluginBase)
        //{
        //    this.pluginBase = pluginBase;
        //}

        private TrayIconData trayData;
        const string m_Shortcut = "";
        private string m_TempPath = null;

        public FARRTrayAction(TrayIconData trayData, string m_TempPath)
            : base("", m_Shortcut)
        {
            this.trayData = trayData;
            this.m_TempPath = m_TempPath;
        }

        protected override void GetDataRaw(ref string Group, ref string PathItem)
        {
            Group = "System Tray Application";
            PathItem = trayData.Text;
            //if (trayData.Text != "Find and Run Robot")      // ignore FARR for now, causes issues
                //this.Icon = GetTrayIcon();
        }

        public override void Execute(ref bool HideOnExecute)
        {            
            EventHandler leftClickEvent = new EventHandler(LeftClickEvent);
            EventHandler rightClickEvent = new EventHandler(RightClickEvent);
            EventHandler doubleLeftClickEvent = new EventHandler(DoubleLeftClickEvent);

            ContextMenuStrip mainMenu = new ContextMenuStrip();
            mainMenu.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
                new ToolStripMenuItem("&Left Click",null,leftClickEvent, "Left Click"),
                new ToolStripMenuItem("&Right Click",null,rightClickEvent, "Right Click"),
                new ToolStripMenuItem("&Double Left Click",null,doubleLeftClickEvent, "Double Left Click")});

            //RECT rect = EnumTray.FARRWinPos();
            //mainMenu.Show(rect.Left, rect.Top);
            mainMenu.Show(Cursor.Position.X, Cursor.Position.Y);
            HideOnExecute = false;
        }

        private void LeftClickEvent(object sender, EventArgs e) { EnumTray.LeftClickEvent(trayData); }
        private void RightClickEvent(object sender, EventArgs e) { EnumTray.RightClickEvent(trayData); }
        private void DoubleLeftClickEvent(object sender, EventArgs e) { EnumTray.DoubleLeftClickEvent(trayData); }

        public override string CaptionRaw
        {
            get { return trayData.Text; }
        }

        private string GetTrayIcon()
        {
            string FileName = Path.Combine(m_TempPath, Path.GetRandomFileName());
            string PngFile = FileName + ".png";
            string IconFile = FileName + ".ico";
            //MessageBox.Show("Png file: " + PngFile);

            //DeleteFile(FileName);
            //DeleteFile(IconFile);


            
            //BP.MakeTransparent();
            //FileStream stream = new FileStream(IconFile, FileMode.CreateNew);
            //Icon BP = EnumTray.MakeIcon(trayData);
            //BP.Save(stream);
            //stream.Close();

            Bitmap BP = EnumTray.MakeIcon(trayData);
            //ResizeBitmap(BP, 32, 32).Save(IconFile, ImageFormat.Bmp);
            BP = ResizeBitmap(BP, 32, 32);
            //Color transColor = BP.GetPixel(0, 31);
            //BP.MakeTransparent(transColor);
            BP.Save(IconFile, System.Drawing.Imaging.ImageFormat.Bmp);
            //ProcessStartInfo proc = new ProcessStartInfo();
            //proc.CreateNoWindow = false;
            //proc.UseShellExecute = true;

            //proc.FileName = "\"" + m_TempPath + "\\..\\png2ico.exe\" \"" + IconFile + "\" \"" + PngFile + "\"";
            ////proc.Arguments = IconFile + " " + PngFile;
            //using (Process icoProc = Process.Start(proc))
            //{
            //    icoProc.WaitForExit();
            //    icoProc.Close();
            //}
            //Process.Start("\"" + m_TempPath + "\\..\\png2ico.exe\" \"" + IconFile + "\" \"" + PngFile + "\"");
            //MessageBox.Show("\"" + m_TempPath + "\\..\\png2ico.exe\" \"" + IconFile + "\" \"" + PngFile + "\"");
            
            //IntPtr Hicon = BP.GetHicon();
            //Icon ico = System.Drawing.Icon.FromHandle(Hicon);
            //Stream st = new FileStream(IconFile, FileMode.Create);
            //BinaryWriter wr = new BinaryWriter(st);
            //ico.Save(st);
            //wr.Close();

            //DeleteFile(PngFile);
            return IconFile;
             
        }

        private static void DeleteFile(string FileName)
        {
            if (File.Exists(FileName))
            {
                File.Delete(FileName);
            }
        }

        private Bitmap ResizeBitmap(Bitmap b, int nWidth, int nHeight)
        {
            Bitmap result = new Bitmap(nWidth, nHeight);
            using (Graphics g = Graphics.FromImage((Image)result))
                g.DrawImage(b, 0, 0, nWidth, nHeight);
            return result;
        }
    }

    class FARRTrayClockAction : ActionItem
    {
        //private readonly FARRPluginBase pluginBase;
        //public FARRTrayClockAction(FARRPluginBase pluginBase)
        //{
        //    this.pluginBase = pluginBase;
        //}
       
        const string m_Shortcut = "";
        private IntPtr HClock;     

        public FARRTrayClockAction(IntPtr HClock)
            : base("", m_Shortcut)
        {
            this.HClock = HClock;
        }

        protected override void GetDataRaw(ref string Group, ref string PathItem)
        {
            Group = "System Tray Application";
            PathItem = "System Tray Clock";
            //this.Icon = GetTrayIcon();
        }

        public override void Execute(ref bool HideOnExecute)
        {
            //EventHandler leftClickClockEvent = new EventHandler(LeftClickClockEvent);
            //EventHandler rightClickClockEvent = new EventHandler(RightClickClockEvent);
            //EventHandler doubleLeftClickClockEvent = new EventHandler(DoubleLeftClickClockEvent);

            //ContextMenuStrip mainMenu = new ContextMenuStrip();
            //mainMenu.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            //    new ToolStripMenuItem("&Left Click",null,leftClickClockEvent, "Left Click"),
            //    new ToolStripMenuItem("&Right Click",null,rightClickClockEvent, "Right Click"),
            //    new ToolStripMenuItem("&Double Left Click",null,doubleLeftClickClockEvent, "Double Left Click")});

            ////RECT rect = EnumTray.FARRWinPos();
            ////mainMenu.Show(rect.Left, rect.Top);
            //mainMenu.Show(Cursor.Position.X, Cursor.Position.Y);
            HideOnExecute = false;
        }

        private void LeftClickClockEvent(object sender, EventArgs e) { EnumTray.LeftClickClockEvent(HClock); }
        private void RightClickClockEvent(object sender, EventArgs e) { EnumTray.RightClickClockEvent(HClock); }
        private void DoubleLeftClickClockEvent(object sender, EventArgs e) { EnumTray.DoubleLeftClickClockEvent(HClock); }

        public override string CaptionRaw
        {
            get { return "Clock: " + DateTime.Now; }
        }
    }
}