﻿using System;
using System.Collections.Generic;
using System.Text;
using FARRCSharpSDK;
using FARRPlugin;
using System.Text.RegularExpressions;
using System.Collections;
using System.IO;
using System.Reflection;
using System.Windows.Forms;

namespace FARRTunes.Lists
{
    class FARRTrayList : ActionsList
    {
        private TrayIconData[] buttonData = null;
        static string m_TempPath = null;

        public FARRTrayList(FARRCSharpPluginBase pluginBase)
            : base(pluginBase, "^tray")
        {
            m_TempPath = Path.Combine(System.IO.Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location), "Temp");
            Directory.CreateDirectory(m_TempPath);
            //MessageBox.Show("m_TempPath value: " + m_TempPath);
        }

        public override int GetActionsCount(string KeyKeywords)
        {
            //KeyKeywords = GetSearch(KeyKeywords);
            string[] Files = Directory.GetFiles(m_TempPath);     // remove temp icon files       
            foreach (string FileName in Files)
                File.Delete(FileName);

            this.ClearTemporaryItems();

            EnumTray.GetTrayData(out buttonData);       // populate tray data
            if (buttonData != null)
            {
                foreach (TrayIconData trayData in buttonData)   // fill SourceList
                    if (trayData.button.fsState != 8)   // only add if button is not invisible 
                    {
                        this.Add(new Actions.FARRTrayAction(trayData, m_TempPath));
                        //MessageBox.Show("Adding item: " + trayData.Text);
                    }
                
                //this.Add(new Actions.FARRTrayClockAction(EnumTray.GetTrayClock()));
                if (this.Count > 9)
                    PluginBase.ExecuteFARRCommand("setshowallmode", "");  // switch to small icons if lots of results
               //MessageBox.Show("Final count: " + this.Count);  
                return this.Count;
            }
            else return 0;
        }
    }
}


/*

                foreach (TrayIconData trayData in buttonData)   // fill SourceList
                {

                    if (trayData.button.fsState != 8)
                    { // only add if button is not invisible 
                        SourceList.Add(new Actions.FARRTrayAction(trayData, m_TempPath));
                        //MessageBox.Show("Added to SL: " + trayData.Text);
                        //MessageBox.Show("SL Count = " + SourceList.Count);
                        //if (SourceList.Count > 10)
                          //  break;
                    }
                }

                foreach (Actions.FARRTrayAction item in SourceList)
                { // Copy SourceList to thisList
                    //MessageBox.Show("Adding item: " + item.CaptionRaw);
                    this.Add(item);
                }
                //MessageBox.Show("Final this count: " + this.Count);   
                if (this.Count > 9)
                    PluginBase.ExecuteFARRCommand("setshowallmode", "");  // switch to small icons if lots of results
                return this.Count;
            }

*/